$(document).on("pageinit", function() {
    //
    $.mobile.buttonMarkup.hoverDelay = 0;
    //
     pageLoad++;
    //to update every 3 pages
    if(pageLoad > 2){
        $.mobile.ajaxEnabled = false; $.mobile.ajaxFormsEnabled = false;
    }
});

$(document).on("pagebeforeshow", function() {
    //$('.ui-icon-carat-r').addClass('fa fa-angle-left');
    $('body div.content').on("swipeleft",function(e){
        window.history.back();
        e.stopImmediatePropagation();
    });
    //
    $('body div.content').on("swiperight",function(e){
        window.history.forward();
        e.stopImmediatePropagation();
    });
    });
$(document).on("pageshow", function() {
    //
    checklang();
    var currentSearchTerm = $('#search-basic',$.mobile.activePage).val() || '';
    //alert(currentSearchTerm);
    //
    if( $('#term-status-lookup').length){
        if(lookup_lang != 'ar'){
            checkTermExistence(currentSearchTerm,"","","lookup");
        }else{
            checkTermExistence("",currentSearchTerm,"","lookup");
        }
    }
    $('form.inset').submit(function(event) {
        if(pageLoad > 2){
            var href = $(this).attr('action')+'&dict='+$(this).find("input[name=dict]").val()+'&q='+$(this).find("input[name=q]").val();
            $.mobile.loading('show');
            event.stopPropagation();
            event.preventDefault();
           window.location.href = href;
        }
    });
    //alert(curpage);
    // update search history
    var searchHistory = JSON.parse(localStorage.getItem('searchHistory_'+curdict)) || [];
    if(currentSearchTerm !=''){
        if(searchHistory.indexOf(currentSearchTerm) == "-1"){
            searchHistory.unshift(currentSearchTerm);
            searchHistory =  searchHistory.slice(0,10);
            localStorage.setItem('searchHistory_'+curdict, JSON.stringify(searchHistory));
        }
    }
    //if history page
    if($('#searchHistory').length){
        showHistory(curdict);
        console.log(searchHistory);
    }
    //if favorite page
    if($('#searchFavorites').length){
        getFavoriteListe(curdict);
    }
});
//
//$(document).on('pageshow', "body", function () { setTimeout(function () { $('#searc-basic').trigger('click'); }, 50); });
function showTransition(event,elem,asyn){
    if(pageLoad > 2){
        var href = $(elem).attr('href');
        event.stopPropagation();
        event.preventDefault();
        $.mobile.loading('show');
        window.location.href = href;
    }  
}
      
function updateSearchLink(curDict,insertVal){
   checklang();
   var curHrefValue= $("#searc-basic").val();
   updateSeacrhIcon(insertVal);
   $("#searchFeldbutton").attr('href','results.php?mode=&dict='+curDict+'&q='+insertVal);
}

function checklang(str){
    str = $("#searc-basic").val();
    str = str.replace(/ |_|\/|\-|=|:|\*|#|\?|=|&|%|$|"|!|'|\+|\.|~|\<|\>|\{|\}|\[|\]|\/|\\|\s|,|`|\)|\(|;|€|«|»|º|§/g,"");
    var arabic_Letters = /ذ|ض|ص|ث|ق|ف|غ|ع|ه|خ|ح|ج|د|ش|س|ي|ب|ل|ا|ت|ن|م|ك|ط|ئ|ء|ؤ|ر|ل|ى|ة|و|ز|ظ|آ|أ|إ/;
    if(arabic_Letters.test(str)){
        $('#searc-basic').addClass('rtl');
        //lang="ar";
    }else{
        $('#searc-basic').removeClass('rtl');
        //lang="la";
    }
}

//$(window).unload(function(){
//   $.mobile.loading('show');
//});

function updateSeacrhIcon(FieldVal){
   if(FieldVal !=""){
      $("#searchFeldbutton").css('display','block');
   }else{
      $("#searchFeldbutton").css('display','none');
   }
}
//
function sendMsg() {
    //alert('test');
      var url = 'send';
      var error = '';
      var $contactform = $('.contact-form');
      $('.contact-form .required').css('background-color','#fff');
      $('.contact-form .required').each(function() {
            if($(this).val() === '') {
                $(this).css('background-color', '#F9F2F4');
                error='xxx';
            }else{
                
            }
      });
      if(error === '') {
              var firstname = $contactform.find('input[name="firstname"]').val();
              var surname = $contactform.find('input[name="surname"]').val();
              var state = $contactform.find('select[name="state"]').val();
              var mobilephone = $contactform.find('input[name="mobilephone"]').val();
              var email = $contactform.find('input[name="email"]').val();
              var message = $contactform.find('textarea[name="message"]').val();
              $.ajax({
                  type : "GET",
                  url : url,
                  data : {
                     firstname : firstname,
                     surname : surname,
                     state : state,
                     mobilephone : mobilephone,
                     email : email,
                     message : message
                   },
                   success : function(data) {
                     if(data == 'success') {
                         $('.contact-thankyou').fadeIn();
                        $contactform.find('input[name="firstname"]').val('');
                        $contactform.find('input[name="surname"]').val('');
                        $contactform.find('textarea[name="message"]').val('');
                        $contactform.find('input[name="email"]').val('');
                     } else {
                        jqmSimpleMessage('Unable to send your message. Please try again.',3000);
                     }
                   }
              });
      }
      return false;
}

function updateLinks(inputvalue){
   if(inputvalue !=''){
           $("#dictList a").each(function(idx) {
                var curId = $(this).attr('id');
                //to be removed when all dict online
                //if(curId == "en" || curId == "de" || curId == "fr"){
                  $(this).attr('href','results.php?mode=&dict='+curId+'&q='+inputvalue);
                  getCountRequest(curId,$(this).attr('href'));
                //}
           });
           
   }else{
           $("#dictList a").each(function(idx) {
               var curDictId = $(this).attr('id');
                $(this).attr('href','translate?dict='+curDictId);
                $(this.id+' .ui-li-count').html('0');
           });
   }
}
      
function checkInput(){
   if($('#searchFeld').val() ==''){
           jqmSimpleMessage('Please type in your search term!',1000);
   }
}
      
function jqmSimpleMessage(message,zeit) {
   $("<div class='ui-loader ui-overlay-shadow ui-body-e ui-corner-all'><h1>" + message + "</h1></div>")
       .css({
           display: "block",
           opacity: 0.96,
           top: window.pageYOffset+150
       })
       .appendTo("body").delay(800)
       .fadeOut(zeit, function(){
           $(this).remove();
       });
}
      
function blink(selector, xhr){
   if(xhr.readyState < 4){
      $(selector).fadeOut('slow', function(){
          $(this).fadeIn('slow', function(){
              blink($(this),xhr);
          });
      });      
   }else{
    setTimeout(function (selector, xhr) {
        blink(selector, xhr);
    }, 500);
   }
}
      
function encode(uri) {
   if (encodeURIComponent){
           //phrase = phrase;
           return encodeURIComponent(uri).replace(/%2f/ig, "/");                
   } if (escape) {
           return escape(uri).replace(/%2f/ig, "/"); 
   }
}
      
function toggleDedailsArabic(mehr_id,details_class,spra){
   if($('#'+mehr_id+'').prev().css('display') == 'none'){
      $('#'+mehr_id+'').html(' إغلاق');
      $('#'+mehr_id+'').prev().css('display','inline');
   }else{
      $('#'+mehr_id+'').html('... المزيد');
      $('#'+mehr_id+'').prev().css('display','none');
   }
}
      
function checklang(){
    str = $("#search-wrapper form #search-basic").val();
   var arabic_Letters = /ذ|ض|ص|ث|ق|ف|غ|ع|ه|خ|ح|ج|د|ش|س|ي|ب|ل|ا|ت|ن|م|ك|ط|ئ|ء|ؤ|ر|ل|ى|ة|و|ز|ظ|آ|أ|إ/;
   if(arabic_Letters.test(str)){
     $("#search-wrapper form #search-basic").css({"direction":"rtl","text-align":"right"});
   }else{
       $("#search-wrapper form #search-basic").css({"direction":"ltr","text-align":"left"});
   }
}
      
function showResults(ev){
   $("#translateForm").submit();
   return false;
   ev.preventDefault();
}

function checkTermExistence(la,ar,dict,src){
    params = "arabic=" + ar + "&latin=" + la + "&dict=" + dict +"&src="+src+"&mob=1&sid=" +Math.random();
     $.ajax({
        url: basePath+uilang+"/"+subPath+"-ar/check-term-existence?term="+encode(ar+la),
        global: false,
        type: "POST",
        data: params,
        dataType: "html",
        success: function(msg){       
            $('#term-status-'+src,$.mobile.activePage).html('').append(msg);
        }
    });
}

function checkDetails(latin,arabic,exampleTxt,elm){
    //alert(latin);voice_files/aussprach_m_2.php?term=test&lg=de
    
    var contElm = $(elm).next().find('>div');
    if ($(contElm).find('audio').length ){
        return;
    }
    var links = $(contElm).find('a');
    var naviTab = '<table><tr>'+
                        '<td class="nav-link"><a class="show-page-loading-msg" href="'+links[0]+'" style="display:block;" onclick="showTransition(event,this,false)"><button class="lIcon fa fa-search"></button></a></td><td class="audioLa" class="nav-link"></td>'+
                        '<td class="nav-examples"><a href="#" onclick="addToFavoriteListe(event,this)"><button class="lIcon fa fa-star"></button> </a></td>'+
                        '<td class="nav-examples"><a href="'+links[1]+'" onclick="showTransition(event,this,false)"><button class="lIcon fa fa-bars"> '+exampleTxt+'</button> </a></td>'+
                        '<td class="audioAr" class="nav-link"></td><td class="nav-link"><a href="'+links[2]+'" style="display:block;" onclick="showTransition(event,this,false)"><button class="lIcon fa fa-search"></button></a></td>'+
            '</tr></table>';
    //alert($(elm).parent().css('background-color'));
    $(contElm).html(naviTab).css({'background-color':$(elm).parent().css('background-color')});
    params = "term=" + latin + "&lg=" + subPath + "&mode=mobile&sid=" +Math.random();
     $.ajax({
        url: basePath+"voice_files/aussprach_m.php",
        global: false,
        type: "GET",
        data: params,
        dataType: "html",
        success: function(msg){ 
            $(contElm).find('.audioLa').html(msg);
        }
    });
    //
    //arabic
    params_ar = "term="+arabic+"&lg=ar&mode=mobile&sid=" +Math.random();
    $.ajax({
       url: basePath+"voice_files/aussprach_m.php",
       global: false,
       type: "GET",
       data: params_ar,
       dataType: "html",
       success: function(msg_ar){ 
           $(contElm).find('.audioAr').html(msg_ar);
       }
   });
}
//
function playAudio(elm){
    $(elm).next().play();
}
//
function showHistory(dict){
    if (window.localStorage) {
        try {
            console.log(dict);
            var searchHistory = JSON.parse(localStorage.getItem('searchHistory_'+dict)) || [];
            //
            var history = '';
            searchHistory.forEach(function(searchHistoryElemnt) {
               if(searchHistoryElemnt != ""){
                   var searchUrl = basePath+"m/results.php?lang="+uilang+"&dict="+subPath+"&q="+encode(searchHistoryElemnt);
                   console.log(searchUrl);
                   history += '<li><a href="'+searchUrl+'">'+searchHistoryElemnt+'</a></li>';
               }
            });
            console.log(history);
            $("#searchHistory").html('<ul>'+history+'</ul>');
        } catch(err) {}
    }
}
//
function addToFavoriteListe(e,elm){
    e.preventDefault();
    e.stopPropagation();
    if (window.localStorage) {
        try {
            var pairContainer = $(elm).parent().parent().parent().parent().parent().parent().prev();
            var arabic = pairContainer.find('.arabic-term').text();
            var latin = pairContainer.find('.latin-term').text();
            var favoriteList = JSON.parse(localStorage.getItem('favoriteList_'+curdict)) || [];
            //if we do not have valid array, start new one
            if(favoriteList instanceof Array ===false){ favoriteList = []; }
            console.log(favoriteList instanceof Array);
            if(arabic && latin){
                var tmp_array = [latin,arabic];
                console.log(tmp_array);
                //favoriteList.unshdift(tmp_array);
                favoriteList.push(tmp_array);
                favoriteList =  favoriteList.slice(0,20);
                localStorage.setItem('favoriteList_'+curdict, JSON.stringify(favoriteList));
                $(elm).hide();
            }
        } catch(err) {}
    }
}
//
function getFavoriteListe(dict){
    if (window.localStorage) {
        try {
            var favoriteList = JSON.parse(localStorage.getItem('favoriteList_'+dict)) || [];
            //
            var favorites = '';
            var index = 0;
            //if(listElement instanceof Array){
            console.log(favoriteList);
            if(favoriteList instanceof Array !=false && favoriteList.length > 0){   
                favoriteList.forEach(function(listElement){
                    //alert(searchHistoryElemnt);
                   if(listElement){
                       favorites += '<li><span><a href="#" onclick="removeFromFavorite(event,this,'+index+')" class="deleteIcon")> <i class="fa fa-times fa-2x"/> </a></span><span class="latin">'+listElement[0]+' </span><span class="arabic"> '+listElement[1]+'</span></li>';
                       index++;
                    }
                });
            }else{
                favoriteList=[];
            }
            //
            $("#searchFavorites").html('<ul>'+favorites+'</ul>');
        } catch(err) {}
    }
 }
 
 function removeFromFavorite(e,elem,index){
    e.preventDefault();
    e.stopPropagation();
    if (window.localStorage) {
        try {
            console.log(index);
            var favoriteList = JSON.parse(localStorage.getItem('favoriteList_'+curdict)) || [];
            if(favoriteList instanceof Array !=false){ 
                favoriteList.splice(index, 1);
                console.log(favoriteList);
                localStorage.setItem('favoriteList_'+curdict, JSON.stringify(favoriteList));
            }
        } catch(err) {}
        window.location.href = window.location.href;
    }
 }